<?php
/**
 * Created by PhpStorm.
 * User: dale047
 * Date: 2019/3/5
 * Time: 下午4:55
 */
namespace app\login\controller;
use think\Controller;
use app\common\lib;

class Index extends Controller
{
    public function _initialize()
    {
        parent::_initialize(); // TODO: Change the autogenerated stub
        $SiteName = Model('Config')->getSiteName();
        $this->assign('SiteName',$SiteName);
    }

    /**
     * @return mixed|void
     * 登录系统，记录登录信息
     */
    public function index()
    {
        /*引入离线SDK包*/
        include EXTEND_PATH.'AipFace.php';

        if (request()->isPOST()){
            /*判断文件格式、移动文件*/
            $res = lib\MoveFile::UpFaceFile();
            if(empty($res)) {
                $this->error('参数错误');
            }

            /*测试文件完整性*/
            //var_dump($res);

            /*获取文件路径信息*/
            $info = lib\MoveFile::getFileMsg($res);

            /*处理图片相关*/
            /*$File = new lib\MoveFile();
            $File->ReImg($info['path']);*/

            // 你的 APPID AK SK
            /*
            $APP_ID = '14590815';
            $API_KEY = 'EIOPoRRbRFPClzo296hvft7O';
            $SECRET_KEY = '6GFc82iBMkCEjFHYg0YxkanRtmPyOkSO';
            */

            //Loader::import('AipFace',EXTEND_PATH);
            $client = new \AipFace(config('face.APP_ID'), config('face.API_KEY'), config('face.SECRET_KEY'));

            //定义需要检测的图片
            $image = base64_encode(file_get_contents($info['path'])); //base64_encode()里面存放的数据资源，但是不能放路径

            //人脸搜寻
            $imageType = "BASE64";

            $groupIdList = "student_face";

            // 调用人脸搜索
            $result = $client->search($image, $imageType, $groupIdList);

            //print_r($result['error_msg']);
            //print_r($result['result']['user_list']['0']['score']);

            if($result['error_msg']!="SUCCESS" || $result['result']['user_list']['0']['score']<90){
                $this->error('查询不到该同学');
            }

            /*获取学生学号 echo  $result['result']['user_list']['0']['user_id'];*/
            $userId = $result['result']['user_list']['0']['user_id'];

            /*获取当前登录用户的班级信息*/
            $UserInfo = $this->getThisLoginUser($userId);
            $class_id = $UserInfo['class_id'];

            /*存取登录信息*/
            $Idata = [
                'status' => config('login.login_status'),
                'user_num' => $userId,
                'class_id' => $class_id,
                'username' => $result['result']['user_list']['0']['user_info'],
                'last_login_time' => time(),
                'last_login_ip' => \request()->ip(),
            ];
            try{
                $userId = Model('Userlogin')->SaveLoginInfo($Idata);
            }catch (\Exception $e){
                $this->error($e->getMessage());
            }

            session(config('login.session_user'),$userId,config('login.session_user_scope'));

            $this->success('验证成功，欢迎你 '.$result['result']['user_list']['0']['user_info'],'index/index/index');
        }else {
            return $this->fetch();
        }
    }

    public function logout()
    {
        session(null,config('login.session_user_scope'));
        $this->success('退出成功','login/index/index');
    }

    public function getThisLoginUser($user_num)
    {
        $UserInfo = Model('Student')->get(['user_num'=>$user_num]);
        return $UserInfo;
    }
}